#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=gm.ico
#AutoIt3Wrapper_outfile=Gmailer.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Tidy_Stop_OnError=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

Global $masterPass = "matwachich", $Increase = 0
FileInstall("c:\windows\system32\sqlite3.dll", @SystemDir&"\sqlite3.dll")

#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <ListviewConstants.au3>
#include <string.au3>
#include <sqlite.au3>


TraySetState(2)

#Region ### START Koda GUI section ### Form=
$Form1 = GUICreate("Gmailer", 515, 438)
$menu_file = GUICtrlCreateMenu("Fichier")
$menu_new = GUICtrlCreateMenuItem("Nouveau", $menu_file)
$menu_open_mail = GUICtrlCreateMenuItem("Ouvrir message", $menu_file)
$menu_save_msg = GUICtrlCreateMenuItem("Sauvegarder message", $menu_file)
$MenuItem1 = GUICtrlCreateMenuItem("", $menu_file)
$menu_quit = GUICtrlCreateMenuItem("Quitter", $menu_file)
$menu_adr_book = GUICtrlCreateMenu("&Carnet d'addresses")
$menu_add_contact = GUICtrlCreateMenuItem("Ajouter", $menu_adr_book)
$menu_browse_contact = GUICtrlCreateMenuItem("Parcourir", $menu_adr_book)
$menu_config = GUICtrlCreateMenu("C&onfiguration")
$menu_compte = GUICtrlCreateMenuItem("Comptes Gmail", $menu_config)
$menu_help = GUICtrlCreateMenu("&Aide")
GUICtrlCreateLabel("Votre nom :", 16, 12, 108, 17)
GUICtrlCreateLabel("Adresse du destinataire :", 16, 36, 116, 17)
GUICtrlCreateLabel("Sujet :", 16, 92, 36, 17)
GUICtrlCreateLabel("Cc :", 312, 16, 28, 17)
GUICtrlCreateLabel("Bcc :", 312, 36, 28, 17)
GUICtrlCreateLabel("Pices jointes :", 16, 58, 76, 17)
GUICtrlCreateLabel("Corps du message :", 16, 116, 108, 17)
GUICtrlCreateLabel("Priorit :", 312, 90, 42, 17)
GUICtrlCreateLabel("Compte utilis :", 16, 384, 75, 17)
$input_your_name = GUICtrlCreateInput("", 136, 8, 161, 21)
$input_to_mail = GUICtrlCreateInput("", 136, 32, 161, 21)
$input_cc_adresse = GUICtrlCreateInput("", 360, 8, 137, 21)
$input_bcc_adresse = GUICtrlCreateInput("", 360, 32, 137, 21)
$input_attach = GUICtrlCreateInput("", 136, 56, 329, 21)
$attache = GUICtrlCreateButton("", 472, 56, 25, 21, BitOR($BS_ICON,$WS_GROUP))
	GUICtrlSetImage(-1, "shell32.dll", "5", 0)
$input_sujet = GUICtrlCreateInput("", 56, 88, 241, 21)
$corps = GUICtrlCreateEdit("", 16, 136, 481, 241, BitOR($ES_AUTOVSCROLL,$ES_WANTRETURN,$WS_VSCROLL))
GUICtrlSetData(-1, "")
$send = GUICtrlCreateButton("Envoyer", 312, 384, 185, 25, $WS_GROUP)
$combo_priorite = GUICtrlCreateCombo("", 360, 88, 137, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
GUICtrlSetData(-1, "Faible|Normal|Elev")
$compte_label = GUICtrlCreateLabel("", 96, 384, 200, 17)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

_SQLite_Startup()
DirCreate(@AppDataDir&"\Gmailer\")
_SQLite_Open(@AppDataDir&"\Gmailer\data.sqlite")

Dim $temp, $whereInsertContact = ""
If _SQLite_Query(-1, "SELECT * FROM identifiants", $temp) <> $SQLITE_OK Then
	_SQLite_Exec(-1, "CREATE TABLE IF NOT EXISTS identifiants (id, user, pass)")
	_SQLite_Exec(-1, "INSERT INTO identifiants VALUES('index', '', '')")
EndIf
_SQLite_QueryFinalize($temp)

_SQLite_Exec(-1, "CREATE TABLE IF NOT EXISTS contacts (nom, mail, time DEFAULT CURRENTTIMESTAMP)")
_SQLite_Exec(-1, "CREATE TABLE IF NOT EXISTS messages ('id' INTEGER PRIMARY KEY AUTOINCREMENT, time DEFAULT CURRENT_TIMESTAMP, nom, dest, cc, bcc, priorite, sujet, piece, corps)")

OnAutoItExitRegister("_exit")
Func _exit()
	_SQLite_Close()
	_SQLite_Shutdown()
EndFunc

Global $user_name, $password
_sql_read_user($user_name, $password)
GUICtrlSetData($compte_label, $user_name)

If $user_name = "" Or $password = "" Then
	_Config()
EndIf

If $user_name = "" Then
	MsgBox(16, "Gmailer", "Aucun compte Gmail n'est slectionn!"&@crlf&"Cliquez sur Configuration -> Compte Gmail pour en slectioner un")
EndIf

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit(0)
		Case $menu_quit
			Exit(0)
		Case $menu_new
			_New()
		Case $send
			If _verifSend() = True Then _Send()
		Case $attache
			_attach()
		Case $menu_compte
			_Config()
		Case $menu_save_msg
			_saveMsg()
		Case $menu_open_mail
			_openMail()
		Case $menu_add_contact
			_addContact()
		Case $menu_browse_contact
			$data = _browsContacts($whereInsertContact)
			Switch $whereInsertContact
				Case "dest"
					GUICtrlSetData($input_to_mail, $data)
				Case "cc"
					GUICtrlSetData($input_cc_adresse, $data)
				Case "bcc"
					GUICtrlSetData($input_bcc_adresse, $data)
				Case "body"
					GUICtrlSetData($corps, GUICtrlRead($corps)&" "&$data)
			EndSwitch
			$whereInsertContact = ""
	EndSwitch
WEnd

Func _attach()
	If GUICtrlRead($input_attach) = "" Then
		GUICtrlSetData($input_attach, FileOpenDialog("Pice jointe", @DesktopDir, "All (*.*)", 1))
	Else
		GUICtrlSetData($input_attach, GUICtrlRead($input_attach)&';'&FileOpenDialog("Pice jointe", @DesktopDir, "All (*.*)", 1))
	EndIf
EndFunc

#include "messages_save.au3"
#include "functions.au3"
#include "contacts.au3"

Func _verifSend()
	$ok = True
	If GUICtrlRead($input_to_mail) = "" Then
		$ok = False
		GUICtrlSetBkColor($input_to_mail, 0xFF9D8C)
	EndIf
	Return $ok
EndFunc

Func _New()
	If MsgBox(36, "Gmailer", "Etes-vous sure?") = 7 Then
		Return 0
	Else
		GUICtrlSetData($input_your_name, "")
		GUICtrlSetData($input_to_mail, "")
		GUICtrlSetData($input_cc_adresse, "")
		GUICtrlSetData($input_bcc_adresse, "")
		GUICtrlSetData($input_attach, "")
		GUICtrlSetData($input_sujet, "")
		GUICtrlSetData($corps, "")
	EndIf
EndFunc

Func _Config()
	#Region ### START Koda GUI section ### Form=
	local $Form2 = GUICreate("Configuration", 226, 210, -1, -1, -1, -1, $Form1)
	GUICtrlCreateLabel("Configuration : ", 8, 8, 75, 17)
	GUICtrlCreateLabel("Entrez un compte Gmail valdie pour pouvoir", 8, 24, 209, 17)
	GUICtrlCreateLabel("utiliser Gmailer", 8, 40, 71, 17)
	GUICtrlCreateGroup("", 8, 56, 209, 113)
	GUICtrlCreateLabel("Nom utilisateur :", 16, 72, 79, 17)
	GUICtrlCreateLabel("Mot de passe :", 16, 120, 74, 17)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	local $input_user = GUICtrlCreateInput("", 16, 88, 193, 21)
	local $input_passe = GUICtrlCreateInput("", 16, 136, 193, 21, $ES_PASSWORD)
	Local $valider = GUICtrlCreateButton("Valider", 8, 176, 209, 25, $WS_GROUP)

	GUISetState(@SW_SHOW, $Form2)
	#EndRegion ### END Koda GUI section ###

	If $user_name <> "" Then
		MsgBox(0, "Compte utilisateur", "Vous utilisez le comptes:"&@crlf&$user_name)
	EndIf

	If $user_name <> "" Or $password <> "" Then
		GUICtrlSetData($input_user, $user_name)
		GUICtrlSetData($input_passe, $password)
	EndIf

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				GUISetState(@SW_HIDE, $Form2)
				ExitLoop
			Case $valider
				If GUICtrlRead($input_user) = "" Then
					If MsgBox(49, "Gmailer", "Sans compte Gmail valide, il est impossible d'utiliser Gmailer!"&@crlf&"Appuyez sur OK pour saisir un compte Gmail, ou sur ANNULER pour quitter") = 2 Then
						MsgBox(64, "Gmailer", "Au revoir!")
						Exit
					EndIf
				ElseIf GUICtrlRead($input_user) <> "" Then
					$user_name = GUICtrlRead($input_user)
					$password = GUICtrlRead($input_passe)
					If MsgBox(36, "Gmailer", "Voulez-vous sauvegarder ces identifiants (de manire crypt bien sur!) afin de les utilis comme identifiants par defauts?") = 6 Then
						_sql_write_user($user_name, $password)
					EndIf
					GUISetState(@SW_HIDE, $Form2)
					ExitLoop
				EndIf
		EndSwitch
	WEnd

	GUICtrlSetData($compte_label, $user_name)

EndFunc

Func _Send()
$answer = MsgBox(33, "Confirmation", "Envoyer le mail?")
	If $answer = 2 Then
		return 0
	ElseIf $answer <> 2 Then
		If _TestConnection() = False Then
			If MsgBox(49, "Gmailer", "Connection internet indisponible!"& @CRLF &"Continuer?") = 2 Then Return
		EndIf

		If GUICtrlRead($input_attach) <> "" Then
			If Not _verifAttach() Then
				If MsgBox(49, "Gmailer", "Le fichier joint n'existe pas!"& @CRLF &"Continuer?") = 2 Then Return
			EndIf
		EndIf

		If GUICtrlRead($input_attach) <> "" Then
			MsgBox(48, "Gmailer", "Votre e-mail comporte une pice jointe."&@crlf&"selon sa taille, l'envoi peut durer plus ou moin longtemps."&@crlf&"Veuillez patienter jusqu' confirmation de l'envoi")
		EndIf

		WinSetTitle($Form1, "", "Gmailer - Envoi en cours...")

		$return = _INetSmtpMailCom("smtp.gmail.com", _
									GUICtrlRead($input_your_name), _
									$user_name, _
									GUICtrlRead($input_to_mail), _
									GUICtrlRead($input_sujet), _
									GUICtrlRead($corps), _
									GUICtrlRead($input_attach), _
									GUICtrlRead($input_cc_adresse), _
									GUICtrlRead($input_bcc_adresse), _
									GUICtrlRead($combo_priorite), _
									$user_name, $password, 465, 1)
; ICI IL DOIT Y AVOIR LA GESTION DES ERREURS

		WinSetTitle($Form1, "", "Gmailer")

	EndIf
	GUICtrlSetBkColor($input_to_mail, 0xFFFFFF)
	MsgBox(64, "Gmailer", "Mssage envoy!")
EndFunc

