Func _addContact()
	#Region ### START Koda GUI section ### Form=
	$Form4 = GUICreate("Ajouter un contact", 290, 87)
	GUICtrlCreateLabel("Nom", 8, 8, 26, 17)
	GUICtrlCreateLabel("E-mail", 8, 32, 32, 17)
	$input_name = GUICtrlCreateInput("", 48, 8, 233, 21)
	$input_mail = GUICtrlCreateInput("", 48, 32, 233, 21)
	$b_valider = GUICtrlCreateButton("Valider", 192, 56, 75, 25, $WS_GROUP)
	$b_annuler = GUICtrlCreateButton("Annuler", 112, 56, 75, 25, $WS_GROUP)
	GUISetState(@SW_SHOW)
	#EndRegion ### END Koda GUI section ###

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				GUISetState(@SW_HIDE, $Form4)
				Return
			Case $b_annuler
				GUISetState(@SW_HIDE, $Form4)
				Return
			Case $b_valider
				If _SQLite_Exec(-1, "INSERT INTO contacts VALUES('" & _sqlSpecialChars(GUICtrlRead($input_name)) & "','" & _sqlSpecialChars(GUICtrlRead($input_mail)) & "', CURRENT_TIMESTAMP)") <> $SQLITE_OK Then
					_erreur()
					GUISetState(@SW_HIDE, $Form4)
					Return
				Else
					_info("Contact ajout(e)!")
					GUISetState(@SW_HIDE, $Form4)
					Return
				EndIf
		EndSwitch
	WEnd
EndFunc

Func _browsContacts(ByRef $where)
	Local $query, $data
	#Region ### START Koda GUI section ### Form=
	$Form5 = GUICreate("Contacts", 463, 402, 192, 125)
	$liste = GUICtrlCreateListView("Heur                        |Nom                   |E-mail                  ", 8, 8, 353, 385, BitOr($GUI_SS_DEFAULT_LISTVIEW, $LVS_EX_FULLROWSELECT))
	GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 0, 50)
	GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 1, 50)
	GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 2, 50)
	$b_dest = GUICtrlCreateButton("Destinataire", 376, 32, 75, 25, $WS_GROUP)
	$b_cc = GUICtrlCreateButton("Cc", 376, 64, 75, 25, $WS_GROUP)
	$b_bcc = GUICtrlCreateButton("Bcc", 376, 96, 75, 25, $WS_GROUP)
	$b_del = GUICtrlCreateButton("Supprimer", 376, 208, 75, 25, $WS_GROUP)
	$b_add = GUICtrlCreateButton("Ajouter", 376, 176, 75, 25, $WS_GROUP)
	$Label1 = GUICtrlCreateLabel("Inserer en tant que", 368, 8, 93, 17)
	$b_body = GUICtrlCreateButton("Dans le corps", 376, 128, 75, 25, $WS_GROUP)
	GUISetState(@SW_SHOW)
	#EndRegion ### END Koda GUI section ###

	_SQLite_Query(-1, "SELECT time,nom,mail FROM contacts ORDER BY nom ASC", $query)

	$i = 1
	While _SQLite_FetchData($query, $data) = $SQLITE_OK
		Assign("item_"&$i, GUICtrlCreateListViewItem($data[0]&"|"&$data[1]&"|"&$data[2], $liste))
		ConsoleWrite("Assigned item_"&$i & @CRLF)
		$i += 1
	WEnd
	$nbrItems = $i - 1
	ConsoleWrite($nbrItems & @CRLF)

	_SQLite_QueryFinalize($query)


	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				GUISetState(@SW_HIDE, $Form5)
				Return
			Case $b_del
				$key = GUICtrlRead(GUICtrlRead($liste))
				If $key <> "" Then
					$key = StringLeft($key, 19)
					ConsoleWrite($key & @CRLF)
					_SQLite_Exec(-1, "DELETE FROM contacts WHERE time='" & $key & "'")

					For $i = 1 To $nbrItems Step 1
						If Eval("item_"&$i) = GUICtrlRead($liste) Then GUICtrlDelete(Eval("item_"&$i))
					Next
					$nbrItems -= 1
					ConsoleWrite($nbrItems & @CRLF)
				EndIf
			Case $b_add
				_addContact()

				For $i = 1 To $nbrItems + 1 Step 1
					If Eval("item_"&$i) <> 0 Then GUICtrlDelete(Eval("item_"&$i))
				Next

				_SQLite_Query(-1, "SELECT time,nom,mail FROM contacts ORDER BY nom ASC", $query)

				$i = 1
				While _SQLite_FetchData($query, $data) = $SQLITE_OK
					Assign("item_"&$i, GUICtrlCreateListViewItem($data[0]&"|"&$data[1]&"|"&$data[2], $liste))
					ConsoleWrite("Assigned item_"&$i & @CRLF)
					$i += 1
				WEnd
				$nbrItems = $i - 1
				ConsoleWrite($nbrItems & @CRLF)

				_SQLite_QueryFinalize($query)
			Case $b_dest
				$key = GUICtrlRead(GUICtrlRead($liste))
				If $key <> "" Then
					$key = StringLeft($key, 19)
					_SQLite_Query(-1, "SELECT mail FROM contacts WHERE time='" & $key & "'", $query)
					_SQLite_FetchData($query, $data)
					_SQLite_QueryFinalize($query)

					$where = "dest"

					GUISetState(@SW_HIDE, $Form5)
					ConsoleWrite($data[0] & @CRLF)
					Return $data[0]
				EndIf
			Case $b_cc
				$key = GUICtrlRead(GUICtrlRead($liste))
				If $key <> "" Then
					$key = StringLeft($key, 19)
					_SQLite_Query(-1, "SELECT mail FROM contacts WHERE time='" & $key & "'", $query)
					_SQLite_FetchData($query, $data)
					_SQLite_QueryFinalize($query)

					$where = "cc"

					GUISetState(@SW_HIDE, $Form5)
					Return $data[0]
				EndIf
			Case $b_bcc
				$key = GUICtrlRead(GUICtrlRead($liste))
				If $key <> "" Then
					$key = StringLeft($key, 19)
					_SQLite_Query(-1, "SELECT mail FROM contacts WHERE time='" & $key & "'", $query)
					_SQLite_FetchData($query, $data)
					_SQLite_QueryFinalize($query)

					$where = "bcc"

					GUISetState(@SW_HIDE, $Form5)
					Return $data[0]
				EndIf
			Case $b_body
				$key = GUICtrlRead(GUICtrlRead($liste))
				If $key <> "" Then
					$key = StringLeft($key, 19)
					_SQLite_Query(-1, "SELECT mail FROM contacts WHERE time='" & $key & "'", $query)
					_SQLite_FetchData($query, $data)
					_SQLite_QueryFinalize($query)

					$where = "body"

					GUISetState(@SW_HIDE, $Form5)
					Return $data[0]
				EndIf

		EndSwitch
	WEnd

EndFunc
