Func _openMail()
	Local $query, $data
	#Region ### START Koda GUI section ### Form=
	$Form3 = GUICreate("Messages", 467, 433)
	$liste = GUICtrlCreateListView("Heur                       |Destinataire                       |Sujet                                   ", 8, 8, 449, 385, BitOr($GUI_SS_DEFAULT_LISTVIEW, $LVS_EX_FULLROWSELECT))
	$b_open = GUICtrlCreateButton("Ouvrir", 384, 400, 75, 25, $WS_GROUP)
	$b_supr = GUICtrlCreateButton("Supprimer", 304, 400, 75, 25, $WS_GROUP)
	GUISetState(@SW_SHOW)
	#EndRegion ### END Koda GUI section ###

	_SQLite_Query(-1, "SELECT time,dest,sujet FROM messages ORDER BY time DESC", $query)

	$i = 1
	While _SQLite_FetchData($query, $data) = $SQLITE_OK
		Assign("item_"&$i, GUICtrlCreateListViewItem($data[0]&"|"&$data[1]&"|"&$data[2], $liste))
		ConsoleWrite("Assigned item_"&$i & @CRLF)
		$i += 1
	WEnd
	$nbrItems = $i - 1
	ConsoleWrite($nbrItems & @CRLF)

	_SQLite_QueryFinalize($query)

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				GUISetState(@SW_HIDE, $Form3)
				Return
			Case $b_open
				$key = GUICtrlRead(GUICtrlRead($liste))
				If $key <> "" Then
					$key = StringLeft($key, 19)
					ConsoleWrite($key & @CRLF)

					If _SQLite_Query(-1, "SELECT nom,dest,cc,bcc,priorite,sujet,piece,corps FROM messages WHERE time='" & $key & "' LIMIT 1", $query) <> $SQLITE_OK Then
						MsgBox(16, "Gmailer", "Erreur fatale")
						GUISetState(@SW_HIDE, $Form3)
						Return
					EndIf
					_SQLite_FetchData($query, $data)

					_SQLite_QueryFinalize($query)

					GUICtrlSetData($input_your_name, $data[0])
					GUICtrlSetData($input_to_mail, $data[1])
					GUICtrlSetData($input_cc_adresse, $data[2])
					GUICtrlSetData($input_bcc_adresse, $data[3])
					GUICtrlSetData($combo_priorite, $data[4])
					GUICtrlSetData($input_sujet, $data[5])
					GUICtrlSetData($input_attach, StringReplace($data[6], "\\", "\"))
					GUICtrlSetData($corps, $data[7])

					GUISetState(@SW_HIDE, $Form3)
					Return
				EndIf
			Case $b_supr
				If MsgBox(36,"Gmailer","Etes-vous sur?") = 6 Then
					$key = GUICtrlRead(GUICtrlRead($liste))
					If $key <> "" Then
						$key = StringLeft($key, 19)
						ConsoleWrite($key & @CRLF)
						_SQLite_Exec(-1, "DELETE FROM messages WHERE time='" & $key & "'")

						For $i = 1 To $nbrItems Step 1
							If Eval("item_"&$i) = GUICtrlRead($liste) Then GUICtrlDelete(Eval("item_"&$i))
						Next
						$nbrItems -= 1
						ConsoleWrite($nbrItems & @CRLF)
					EndIf
				EndIf
		EndSwitch
	WEnd

EndFunc

Func _saveMsg()
	$values = "NULL, CURRENT_TIMESTAMP, "
	$values &= "'"&_sqlSpecialChars(GUICtrlRead($input_your_name))&"', "
	$values &= "'"&_sqlSpecialChars(GUICtrlRead($input_to_mail))&"', "
	$values &= "'"&_sqlSpecialChars(GUICtrlRead($input_cc_adresse))&"', "
	$values &= "'"&_sqlSpecialChars(GUICtrlRead($input_bcc_adresse))&"', "
	$values &= "'"&_sqlSpecialChars(GUICtrlRead($combo_priorite))&"', "
	$values &= "'"&_sqlSpecialChars(GUICtrlRead($input_sujet))&"', "
	$values &= "'"&_sqlSpecialChars(GUICtrlRead($input_attach))&"', "
	$values &= "'"&_sqlSpecialChars(GUICtrlRead($corps))&"'"
	If _SQLite_Exec(-1, "INSERT INTO messages VALUES(" & $values & ")") <> $SQLITE_OK Then
		_erreur()
		Return
	EndIf
	MsgBox(64, "Gmailer", "Message enregistr")
EndFunc
